''************************
''*   MIDI expander      *
''************************
'' Author:   Andy Schenk, Insonix
'' Date:     April 2009

'' uses the PhaseMod GM Synthesizer to play the MIDI events from the RX input.

'' Lightshow added by Jeff Ledger/Oldbitcollector

CON
  _clkmode        = xtal1 + pll16x
  _xinfreq        = 5_000_000

  SD_basepin      = 16       '<-- SD card
  Left            = 10       '<-- Audio Out pins
  Right           = 11
  Video_basepin   = 12       '<-- Video Basepin      

OBJ
  midi  : "FD_Serial_Conf"  'FDserial with 128 byte rx-buffer
  synth : "pm_synth_20"
  text  : "aigeneric_driver" 


PUB Main
  text.start(12)                                        '<-- textlay basepin
  midi.start(31,30,0,38400)                             'MIDI input (PropPlug)
'  midi.start(InPin,OutPin,0,31250)                      'Hardware MIDI input (set right Pins for your hardware)
  synth.start(Left,Right,2)                             'start synth with 20 voices
  text.str(string("             MIDI Expander"))
  midiplay
  repeat
    

PUB midiplay  | lg, dt, b, v, st, d1, d2, ch
  b := st := d1 := d2 := v := 0
  repeat
    b := midi.rx                                  'MIDI byte
    if b > 127 and b < $F0
      st := b                                     'new status byte
    ch := st & $0F
    d1~
    d2~
    case st & $F0                                 'decode MIDI Event
      $90: d1 := midi.rx                          'Note 
           d2 := midi.rx                          'Velocity
           if d2>0
             synth.noteOn(d1,ch,d2)               'Note On
             'show(15,ch+1,string(127),-1)
             'text.out(0)
             text.color(d1)
             text.locate(ch+2,2)
             text.str(string(":::::::::::::::::::::::::::::::::::"))
           else
             synth.noteOff(d1,ch)                 'Note Off if Vel=0
      $80: d1 := midi.rx                          'Note Off 
           d2 := midi.rx                          'Velocity
           synth.noteOff(d1,ch)
           text.locate(ch+2,2)
           text.str(string("                                   "))
      $A0: d1 := midi.rx                          'Poly AfterTouch 
           d2 := midi.rx                          '(not supported)
      $C0: d1 := midi.rx                          'Prg Change 
           synth.prgChange(d1,ch)
           'show(0,ch+1,string("Ch:"),ch+1)
           'show(6,ch+1,string("Prg:"),d1+1)
           
           
           
      $D0: d1 := midi.rx                          'Mono AfterTouch 
      $B0: d1 := midi.rx                          'Controller (nr) 
           d2 := midi.rx                          'value
           if d1==7
             synth.volContr(d2,ch)                '7=Vol
           if d1==10
             synth.panContr(d2,ch)                '10=Pan
           if d1==120
             synth.allOff                         'AllNotes Off
             text.out(0)
             text.str(string("             MIDI Expander")) 
      $E0: d1 := midi.rx                          'Pitch Bender 
           d2 := midi.rx                          '(not supported!)
      $F0: if st==$F0                             'SysEx
             repeat
               v := midi.rx  
             until v==$F7
             d1~
           elseif st==$F2
             d1 := midi.rx                        '3 byte
             d2 := midi.rx  


     
  